Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4550)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4559)
@@ -1569,24 +1570,24 @@
     CHARACTER(LEN=*)  ::  variable    !<
 
-    INTEGER(iwp) ::  av              !< flag to control data output of instantaneous or time-averaged data
+    INTEGER(iwp) ::  av              !< flag to control data output of instantaneous or
+                                     !< time-averaged data
+    INTEGER(iwp) ::  i               !< grid index along x-direction
+    INTEGER(iwp) ::  im              !< loop index for masked variables
+    INTEGER(iwp) ::  j               !< grid index along y-direction
+    INTEGER(iwp) ::  jm              !< loop index for masked variables
+    INTEGER(iwp) ::  k               !< grid index along z-direction
+    INTEGER(iwp) ::  kk              !< masked output index along z-direction
+    INTEGER(iwp) ::  ktt             !< k index of highest terrain surface
     INTEGER(iwp) ::  lsp
-    INTEGER(iwp) ::  i               !< grid index along x-direction
-    INTEGER(iwp) ::  j               !< grid index along y-direction
-    INTEGER(iwp) ::  k               !< grid index along z-direction
-    INTEGER(iwp) ::  im              !< loop index for masked variables
-    INTEGER(iwp) ::  jm              !< loop index for masked variables
-    INTEGER(iwp) ::  kk              !< masked output index along z-direction
     INTEGER(iwp) ::  mid             !< masked output running index
-    INTEGER(iwp) ::  ktt             !< k index of highest terrain surface
-    
+
     LOGICAL ::  found
-    
-    REAL(wp), DIMENSION(mask_size_l(mid,1),mask_size_l(mid,2),mask_size_l(mid,3)) ::  &
-              local_pf   !< 
+
+    REAL(wp), DIMENSION(mask_size_l(mid,1),mask_size_l(mid,2),mask_size_l(mid,3)) ::  local_pf   !<
 
     REAL(wp), PARAMETER ::  fill_value = -9999.0_wp    !< value for the _FillValue attribute
 
 !
-!-- local variables.
+!-- Local variables.
 
     spec_name = TRIM( variable(4:) )
@@ -1594,19 +1595,18 @@
 
     DO  lsp=1,nspec
-       IF (TRIM( spec_name ) == TRIM( chem_species(lsp)%name) )  THEN             
+       IF (TRIM( spec_name ) == TRIM( chem_species(lsp)%name) )  THEN
 !
 !-- todo: remove or replace by "CALL message" mechanism (kanani)
 !              IF(myid == 0 .AND. chem_debug0 )  WRITE(6,*) 'Output of species ' // TRIM( variable )  // &
-!                                                        TRIM( chem_species(lsp)%name )       
+!                                                        TRIM( chem_species(lsp)%name )
           IF (av == 0)  THEN
              IF ( .NOT. mask_surface(mid) )  THEN
 
                 DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2) 
-                      DO  k = 1, mask_size(mid,3) 
-                          local_pf(i,j,k) = chem_species(lsp)%conc(  &
-                                               mask_k(mid,k),        &
-                                               mask_j(mid,j),        &
-                                               mask_i(mid,i)      )
+                   DO  j = 1, mask_size_l(mid,2)
+                      DO  k = 1, mask_size(mid,3)
+                          local_pf(i,j,k) = chem_species(lsp)%conc( mask_k(mid,k),                 &
+                                                                    mask_j(mid,j),                 &
+                                                                    mask_i(mid,i)      )
                       ENDDO
                    ENDDO
@@ -1614,14 +1614,17 @@
 
              ELSE
-!              
+!
 !--             Terrain-following masked output
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
+!
 !--                   Get k index of the highest terraing surface
                       im = mask_i(mid,i)
                       jm = mask_j(mid,j)
-                      ktt = MINLOC( MERGE( 1, 0, BTEST( wall_flags_total_0(:,jm,im), 5 )), DIM = 1 ) - 1
+                      ktt = MINLOC( MERGE( 1, 0, BTEST( wall_flags_total_0(:,jm,im), 5 ) ),        &
+                                    DIM = 1 ) - 1
                       DO  k = 1, mask_size_l(mid,3)
                          kk = MIN( ktt+mask_k(mid,k), nzt+1 )
+!
 !--                      Set value if not in building
                          IF ( BTEST( wall_flags_total_0(kk,jm,im), 6 ) )  THEN
@@ -1641,8 +1644,7 @@
                    DO  j = 1, mask_size_l(mid,2)
                       DO  k =  1, mask_size_l(mid,3)
-                          local_pf(i,j,k) = chem_species(lsp)%conc_av(  &
-                                               mask_k(mid,k),           &
-                                               mask_j(mid,j),           &
-                                               mask_i(mid,i)         )
+                          local_pf(i,j,k) = chem_species(lsp)%conc_av(  mask_k(mid,k),             &
+                                                                        mask_j(mid,j),             &
+                                                                        mask_i(mid,i)         )
                       ENDDO
                    ENDDO
@@ -1650,14 +1652,17 @@
 
              ELSE
-!              
+!
 !--             Terrain-following masked output
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
+!
 !--                   Get k index of the highest terraing surface
                       im = mask_i(mid,i)
                       jm = mask_j(mid,j)
-                      ktt = MINLOC( MERGE( 1, 0, BTEST( wall_flags_total_0(:,jm,im), 5 )), DIM = 1 ) - 1
+                      ktt = MINLOC( MERGE( 1, 0, BTEST( wall_flags_total_0(:,jm,im), 5 )),         &
+                                    DIM = 1 ) - 1
                       DO  k = 1, mask_size_l(mid,3)
                          kk = MIN( ktt+mask_k(mid,k), nzt+1 )
+!
 !--                      Set value if not in building
                          IF ( BTEST( wall_flags_total_0(kk,jm,im), 6 ) )  THEN
@@ -1680,28 +1685,31 @@
     RETURN
 
- END SUBROUTINE chem_data_output_mask      
-
-
-!------------------------------------------------------------------------------!
+ END SUBROUTINE chem_data_output_mask
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Subroutine defining appropriate grid for netcdf variables.
 !> It is called out from subroutine netcdf.
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE chem_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
 
 
     CHARACTER (LEN=*), INTENT(IN)  ::  var          !<
-    LOGICAL, INTENT(OUT)           ::  found        !<
+
     CHARACTER (LEN=*), INTENT(OUT) ::  grid_x       !<
     CHARACTER (LEN=*), INTENT(OUT) ::  grid_y       !<
     CHARACTER (LEN=*), INTENT(OUT) ::  grid_z       !<
 
+    LOGICAL, INTENT(OUT)           ::  found        !<
+
     found  = .TRUE.
 
-    IF ( var(1:3) == 'kc_' .OR. var(1:3) == 'em_' )  THEN                   !< always the same grid for chemistry variables
+    IF ( var(1:3) == 'kc_' .OR. var(1:3) == 'em_' )  THEN                !< always the same grid for
+                                                                         !< chemistry variables
        grid_x = 'x'
        grid_y = 'y'
-       grid_z = 'zu'                             
+       grid_z = 'zu'
     ELSE
        found  = .FALSE.
@@ -1715,19 +1723,21 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Subroutine defining header output for chemistry model
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE chem_header( io )
 
-
-    INTEGER(iwp), INTENT(IN) ::  io            !< Unit of the output file
-    INTEGER(iwp)  :: lsp                       !< running index for chem spcs
-    INTEGER(iwp)  :: cs_fixed 
     CHARACTER (LEN=80)  :: docsflux_chr
     CHARACTER (LEN=80)  :: docsinit_chr
-!
-! Get name of chemical mechanism from chem_gasphase_mod
+
+    INTEGER(iwp), INTENT(IN) ::  io            !< Unit of the output file
+
+    INTEGER(iwp)  :: cs_fixed
+    INTEGER(iwp)  :: lsp                       !< running index for chem spcs
+
+!
+!-- Get name of chemical mechanism from chem_gasphase_mod
     CALL get_mechanism_name
 !
@@ -1736,5 +1746,5 @@
 !
 !-- Gasphase reaction status
-    IF ( chem_gasphase_on )  THEN 
+    IF ( chem_gasphase_on )  THEN
        WRITE( io, 2 )
     ELSE
@@ -1746,12 +1756,11 @@
 !
 !-- Emission mode info
-!-- At the moment the evaluation is done with both emiss_lod and mode_emis
-!-- but once salsa has been migrated to emiss_lod the .OR. mode_emis
-!-- conditions can be removed (ecc 20190513)
-    IF     ( (emiss_lod == 1) .OR. (mode_emis == 'DEFAULT') )        THEN
+!-- At the moment the evaluation is done with both emiss_lod and mode_emis but once salsa has been
+!-- migrated to emiss_lod the .OR. mode_emis conditions can be removed (ecc 20190513)
+    IF     ( ( emiss_lod == 1 )  .OR.  ( mode_emis == 'DEFAULT' ) )        THEN
         WRITE ( io, 5 )
-    ELSEIF ( (emiss_lod == 0) .OR. (mode_emis == 'PARAMETERIZED') )  THEN 
+    ELSEIF ( ( emiss_lod == 0 )  .OR.  ( mode_emis == 'PARAMETERIZED' ) )  THEN
         WRITE ( io, 6 )
-    ELSEIF ( (emiss_lod == 2) .OR. (mode_emis == 'PRE-PROCESSED') )  THEN 
+    ELSEIF ( ( emiss_lod == 2 )  .OR.  ( mode_emis == 'PRE-PROCESSED' ) )  THEN
         WRITE ( io, 7 )
     ENDIF
@@ -1759,5 +1768,5 @@
 !-- Photolysis scheme info
     IF ( photolysis_scheme == "simple" )  THEN
-       WRITE( io, 8 ) 
+       WRITE( io, 8 )
     ELSEIF (photolysis_scheme == "constant" )  THEN
        WRITE( io, 9 )
@@ -1766,7 +1775,7 @@
 !-- Emission flux info
     lsp = 1
-    docsflux_chr ='Chemical species for surface emission flux: ' 
+    docsflux_chr ='Chemical species for surface emission flux: '
     DO WHILE ( surface_csflux_name(lsp) /= 'novalue' )
-       docsflux_chr = TRIM( docsflux_chr ) // ' ' // TRIM( surface_csflux_name(lsp) ) // ','  
+       docsflux_chr = TRIM( docsflux_chr ) // ' ' // TRIM( surface_csflux_name(lsp) ) // ','
        IF ( LEN_TRIM( docsflux_chr ) >= 75 )  THEN
           WRITE ( io, 10 )  docsflux_chr
@@ -1780,12 +1789,12 @@
     ENDIF
 !
-!-- initializatoin of Surface and profile chemical species
+!-- Initialization of Surface and profile chemical species
     lsp = 1
-    docsinit_chr ='Chemical species for initial surface and profile emissions: ' 
+    docsinit_chr ='Chemical species for initial surface and profile emissions: '
     DO WHILE ( cs_name(lsp) /= 'novalue' )
-       docsinit_chr = TRIM( docsinit_chr ) // ' ' // TRIM( cs_name(lsp) ) // ','  
+       docsinit_chr = TRIM( docsinit_chr ) // ' ' // TRIM( cs_name(lsp) ) // ','
        IF ( LEN_TRIM( docsinit_chr ) >= 75 )  THEN
-        WRITE ( io, 11 )  docsinit_chr
-        docsinit_chr = '       '
+          WRITE ( io, 11 )  docsinit_chr
+          docsinit_chr = '       '
        ENDIF
        lsp = lsp + 1
@@ -1803,7 +1812,7 @@
 
 !
-!-- number of variable and fix chemical species and number of reactions
+!-- Number of variable and fix chemical species and number of reactions
     cs_fixed = nspec - nvar
-    WRITE ( io, * ) '   --> Chemical Mechanism        : ', cs_mech 
+    WRITE ( io, * ) '   --> Chemical Mechanism        : ', cs_mech
     WRITE ( io, * ) '   --> Chemical species, variable: ', nvar
     WRITE ( io, * ) '   --> Chemical species, fixed   : ', cs_fixed
@@ -1811,6 +1820,5 @@
 
 
-1   FORMAT (//' Chemistry model information:'/                                  &
-           ' ----------------------------'/)
+1   FORMAT (//' Chemistry model information:'/' ----------------------------'/)
 2   FORMAT ('    --> Chemical reactions are turned on')
 3   FORMAT ('    --> Chemical reactions are turned off')
@@ -1821,6 +1829,6 @@
 8   FORMAT ('    --> Photolysis scheme used =  simple ')
 9   FORMAT ('    --> Photolysis scheme used =  constant ')
-10  FORMAT (/'    ',A)  
-11  FORMAT (/'    ',A) 
+10  FORMAT (/'    ',A)
+11  FORMAT (/'    ',A)
 12  FORMAT (/'   Nesting for chemistry variables: ', L1 )
 13  FORMAT (/'   Offline nesting for chemistry variables: ', L1 )
@@ -1833,9 +1841,9 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Subroutine initializating chemistry_model_mod specific arrays
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE chem_init_arrays
 !
@@ -1845,9 +1853,9 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Subroutine initializating chemistry_model_mod
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE chem_init
 
@@ -1856,11 +1864,11 @@
 !-- introduced additional interfaces for on-demand emission update
 
-!    USE chem_emissions_mod,                                                    &
+!    USE chem_emissions_mod,                                                                        &
 !        ONLY:  chem_emissions_init
-        
-    USE chem_emissions_mod,                                                    &
-        ONLY:  chem_emissions_init, chem_emissions_header_init
-        
-    USE netcdf_data_input_mod,                                                 &
+
+    USE chem_emissions_mod,                                                                        &
+        ONLY:  chem_emissions_header_init, chem_emissions_init
+
+    USE netcdf_data_input_mod,                                                                     &
         ONLY:  init_3d
 
@@ -1874,12 +1882,11 @@
 !
 !-- Next statement is to avoid compiler warning about unused variables
-    IF ( ( ilu_arable + ilu_coniferous_forest + ilu_deciduous_forest + ilu_mediterrean_scrub + &
-           ilu_permanent_crops + ilu_savanna + ilu_semi_natural_veg + ilu_tropical_forest +    &
+    IF ( ( ilu_arable + ilu_coniferous_forest + ilu_deciduous_forest + ilu_mediterrean_scrub +     &
+           ilu_permanent_crops + ilu_savanna + ilu_semi_natural_veg + ilu_tropical_forest +        &
            ilu_urban ) == 0 )  CONTINUE
 
 !
 !-- 20200203 (ECC)
-!-- calls specific emisisons initialization subroutines
-!-- for legacy mode and on-demand mode         
+!-- Calls specific emisisons initialization subroutines for legacy mode and on-demand mode
 
 !    IF ( emissions_anthropogenic )  CALL chem_emissions_init
@@ -1897,7 +1904,6 @@
 
 !
-!-- Chemistry variables will be initialized if availabe from dynamic 
-!-- input file. Note, it is possible to initialize only part of the chemistry
-!-- variables from dynamic input. 
+!-- Chemistry variables will be initialized if availabe from dynamic input file. Note, it is
+!-- possible to initialize only part of the chemistry variables from dynamic input.
     IF ( INDEX( initializing_actions, 'inifor' ) /= 0 )  THEN
        DO  n = 1, nspec
@@ -1917,16 +1923,16 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Subroutine initializating chemistry_model_mod
 !> internal workaround for chem_species dependency in chem_check_parameters
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE chem_init_internal
- 
+
     USE pegrid
 
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  chem_emis, chem_emis_att, input_pids_dynamic, init_3d,          &
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY:  chem_emis, chem_emis_att, input_pids_dynamic, init_3d,                              &
                netcdf_data_input_chemistry_data
 
@@ -1935,6 +1941,6 @@
     INTEGER(iwp) ::  i                 !< running index for for horiz numerical grid points
     INTEGER(iwp) ::  j                 !< running index for for horiz numerical grid points
+    INTEGER(iwp) ::  lpr_lev           !< running index for chem spcs profile level
     INTEGER(iwp) ::  lsp               !< running index for chem spcs
-    INTEGER(iwp) ::  lpr_lev           !< running index for chem spcs profile level
 
     REAL(wp)     ::  flag              !< flag for masking topography/building grid points
@@ -1959,5 +1965,5 @@
     ALLOCATE( spec_conc_2 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
     ALLOCATE( spec_conc_3 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
-    ALLOCATE( phot_frequen(nphot) ) 
+    ALLOCATE( phot_frequen(nphot) )
     ALLOCATE( freq_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nphot) )
     ALLOCATE( bc_cs_t_val(nspec) )
@@ -1976,24 +1982,23 @@
        chem_species(lsp)%tconc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_3 (:,:,:,lsp)
 
-       ALLOCATE (chem_species(lsp)%cssws_av(nysg:nyng,nxlg:nxrg))                   
+       ALLOCATE (chem_species(lsp)%cssws_av(nysg:nyng,nxlg:nxrg))
        chem_species(lsp)%cssws_av    = 0.0_wp
 !
 !--    The following block can be useful when emission module is not applied. &
-!--    if emission module is applied the following block will be overwritten.
-       ALLOCATE (chem_species(lsp)%flux_s_cs(nzb+1:nzt,0:threads_per_task-1))   
-       ALLOCATE (chem_species(lsp)%diss_s_cs(nzb+1:nzt,0:threads_per_task-1))   
-       ALLOCATE (chem_species(lsp)%flux_l_cs(nzb+1:nzt,nys:nyn,0:threads_per_task-1)) 
-       ALLOCATE (chem_species(lsp)%diss_l_cs(nzb+1:nzt,nys:nyn,0:threads_per_task-1))   
-       chem_species(lsp)%flux_s_cs = 0.0_wp                                     
-       chem_species(lsp)%flux_l_cs = 0.0_wp                                     
-       chem_species(lsp)%diss_s_cs = 0.0_wp                                      
-       chem_species(lsp)%diss_l_cs = 0.0_wp                                     
-!
-!--   Allocate memory for initial concentration profiles
-!--   (concentration values come from namelist)
-!--   (@todo (FK): Because of this, chem_init is called in palm before
-!--               check_parameters, since conc_pr_init is used there.
-!--               We have to find another solution since chem_init should
-!--               eventually be called from init_3d_model!!)
+!--    If emission module is applied the following block will be overwritten.
+       ALLOCATE (chem_species(lsp)%flux_s_cs(nzb+1:nzt,0:threads_per_task-1))
+       ALLOCATE (chem_species(lsp)%diss_s_cs(nzb+1:nzt,0:threads_per_task-1))
+       ALLOCATE (chem_species(lsp)%flux_l_cs(nzb+1:nzt,nys:nyn,0:threads_per_task-1))
+       ALLOCATE (chem_species(lsp)%diss_l_cs(nzb+1:nzt,nys:nyn,0:threads_per_task-1))
+       chem_species(lsp)%flux_s_cs = 0.0_wp
+       chem_species(lsp)%flux_l_cs = 0.0_wp
+       chem_species(lsp)%diss_s_cs = 0.0_wp
+       chem_species(lsp)%diss_l_cs = 0.0_wp
+!
+!--   Allocate memory for initial concentration profiles (concentration values come from namelist)
+!--   (@todo (FK): Because of this, chem_init is called in palm before check_parameters, since
+!--                conc_pr_init is used there.
+!--                We have to find another solution since chem_init should eventually be called from
+!--                init_3d_model!!)
        ALLOCATE ( chem_species(lsp)%conc_pr_init(0:nz+1) )
        chem_species(lsp)%conc_pr_init(:) = 0.0_wp
@@ -2002,27 +2007,23 @@
 
 !
-!-- For some passive scalars decycling may be enabled. This case, the lateral 
-!-- boundary conditions are non-cyclic for these scalars (chemical species
-!-- and aerosols), while the other scalars may have
-!-- cyclic boundary conditions. However, large gradients near the boundaries
-!-- may produce stationary numerical oscillations near the lateral boundaries
-!-- when a higher-order scheme is applied near these boundaries. 
-!-- To get rid-off this, set-up additional flags that control the order of the 
-!-- scalar advection scheme near the lateral boundaries for passive scalars 
-!-- with decycling.
+!-- For some passive scalars decycling may be enabled. This case, the lateral boundary conditions
+!-- are non-cyclic for these scalars (chemical species and aerosols), while the other scalars may
+!-- have cyclic boundary conditions. However, large gradients near the boundaries may produce
+!-- stationary numerical oscillations near the lateral boundaries when a higher-order scheme is
+!-- applied near these boundaries.
+!-- To get rid-off this, set-up additional flags that control the order of the scalar advection
+!-- scheme near the lateral boundaries for passive scalars with decycling.
     IF ( scalar_advec == 'ws-scheme' )  THEN
        ALLOCATE( cs_advc_flags_s(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 !
-!--    In case of decyling, set Neumann boundary conditions for wall_flags_total_0 
-!--    bit 31 instead of cyclic boundary conditions.
-!--    Bit 31 is used to identify extended degradation zones (please see
-!--    following comment). 
-!--    Note, since several also other modules like Salsa or other future 
-!--    one may access this bit but may have other boundary conditions, the 
-!--    original value of wall_flags_total_0 bit 31 must not be modified. Hence, 
-!--    store the boundary conditions directly on cs_advc_flags_s. 
-!--    cs_advc_flags_s will be later overwritten in ws_init_flags_scalar and
-!--    bit 31 won't be used to control the numerical order. 
-!--    Initialize with flag 31 only. 
+!--    In case of decyling, set Neumann boundary conditions for wall_flags_total_0 bit 31 instead of
+!--    cyclic boundary conditions.
+!--    Bit 31 is used to identify extended degradation zones (please see following comment).
+!--    Note, since several also other modules like Salsa or other future one may access this bit but
+!--    may have other boundary conditions, the original value of wall_flags_total_0 bit 31 must not
+!--    be modified. Hence, store the boundary conditions directly on cs_advc_flags_s.
+!--    cs_advc_flags_s will be later overwritten in ws_init_flags_scalar and bit 31 won't be used to
+!--    control the numerical order.
+!--    Initialize with flag 31 only.
        cs_advc_flags_s = 0
        cs_advc_flags_s = MERGE( IBSET( cs_advc_flags_s, 31 ), 0, BTEST( wall_flags_total_0, 31 ) )
@@ -2031,8 +2032,8 @@
           IF ( nys == 0  )  THEN
              DO  i = 1, nbgp
-                cs_advc_flags_s(:,nys-i,:) = MERGE(                            &
-                                        IBSET( cs_advc_flags_s(:,nys,:), 31 ), &
-                                        IBCLR( cs_advc_flags_s(:,nys,:), 31 ), &
-                                        BTEST( cs_advc_flags_s(:,nys,:), 31 )  &
+                cs_advc_flags_s(:,nys-i,:) = MERGE(                                                &
+                                                    IBSET( cs_advc_flags_s(:,nys,:), 31 ),         &
+                                                    IBCLR( cs_advc_flags_s(:,nys,:), 31 ),         &
+                                                    BTEST( cs_advc_flags_s(:,nys,:), 31 )          &
                                                   )
              ENDDO
@@ -2040,8 +2041,8 @@
           IF ( nyn == ny )  THEN
              DO  i = 1, nbgp
-                cs_advc_flags_s(:,nyn+i,:) = MERGE(                            &
-                                        IBSET( cs_advc_flags_s(:,nyn,:), 31 ), &
-                                        IBCLR( cs_advc_flags_s(:,nyn,:), 31 ), &
-                                        BTEST( cs_advc_flags_s(:,nyn,:), 31 )  &
+                cs_advc_flags_s(:,nyn+i,:) = MERGE(                                                &
+                                                    IBSET( cs_advc_flags_s(:,nyn,:), 31 ),         &
+                                                    IBCLR( cs_advc_flags_s(:,nyn,:), 31 ),         &
+                                                    BTEST( cs_advc_flags_s(:,nyn,:), 31 )          &
                                                   )
              ENDDO
@@ -2051,8 +2052,8 @@
           IF ( nxl == 0  )  THEN
              DO  i = 1, nbgp
-                cs_advc_flags_s(:,:,nxl-i) = MERGE(                            &
-                                        IBSET( cs_advc_flags_s(:,:,nxl), 31 ), &
-                                        IBCLR( cs_advc_flags_s(:,:,nxl), 31 ), &
-                                        BTEST( cs_advc_flags_s(:,:,nxl), 31 )  &
+                cs_advc_flags_s(:,:,nxl-i) = MERGE(                                                &
+                                                    IBSET( cs_advc_flags_s(:,:,nxl), 31 ),         &
+                                                    IBCLR( cs_advc_flags_s(:,:,nxl), 31 ),         &
+                                                    BTEST( cs_advc_flags_s(:,:,nxl), 31 )          &
                                                   )
              ENDDO
@@ -2060,8 +2061,8 @@
           IF ( nxr == nx )  THEN
              DO  i = 1, nbgp
-                cs_advc_flags_s(:,:,nxr+i) = MERGE(                            &
-                                        IBSET( cs_advc_flags_s(:,:,nxr), 31 ), &
-                                        IBCLR( cs_advc_flags_s(:,:,nxr), 31 ), &
-                                        BTEST( cs_advc_flags_s(:,:,nxr), 31 )  &
+                cs_advc_flags_s(:,:,nxr+i) = MERGE(                                                &
+                                                    IBSET( cs_advc_flags_s(:,:,nxr), 31 ), &
+                                                    IBCLR( cs_advc_flags_s(:,:,nxr), 31 ), &
+                                                    BTEST( cs_advc_flags_s(:,:,nxr), 31 )  &
                                                   )
              ENDDO
@@ -2069,17 +2070,17 @@
        ENDIF
 !
-!--    To initialize advection flags appropriately, pass the boundary flags. 
-!--    The last argument indicates that a passive scalar is treated, where
-!--    the horizontal advection terms are degraded already 2 grid points before
-!--    the lateral boundary to avoid stationary oscillations at large-gradients. 
-!--    Also, extended degradation zones are applied, where horizontal advection of 
-!--    passive scalars is discretized by first-order scheme at all grid points 
-!--    that in the vicinity of buildings (<= 3 grid points). Even though no 
-!--    building is within the numerical stencil, first-order scheme is used. 
+!--    To initialize advection flags appropriately, pass the boundary flags.
+!--    The last argument indicates that a passive scalar is treated, where the horizontal advection
+!--    terms are degraded already 2 grid points before the lateral boundary to avoid stationary
+!--    oscillations at large-gradients.
+!--    Also, extended degradation zones are applied, where horizontal advection of passive scalars
+!--    is discretized by first-order scheme at all grid points that in the vicinity of buildings
+!--    (<= 3 grid points). Even though no building is within the numerical stencil, first-order
+!--    scheme is used.
 !--    At fourth and fifth grid point the order of the horizontal advection scheme
 !--    is successively upgraded.
-!--    These extended degradation zones are used to avoid stationary numerical 
-!--    oscillations, which are responsible for high concentration maxima that may
-!--    appear under shear-free stable conditions. 
+!--    These extended degradation zones are used to avoid stationary numerical oscillations, which
+!--    are responsible for high concentration maxima that may appear under shear-free stable
+!--    conditions.
        CALL ws_init_flags_scalar( bc_dirichlet_cs_l  .OR.  bc_radiation_cs_l,                      &
                                   bc_dirichlet_cs_n  .OR.  bc_radiation_cs_n,                      &
@@ -2089,17 +2090,15 @@
     ENDIF
 !
-!-- Initial concentration of profiles is prescribed by parameters cs_profile
-!-- and cs_heights in the namelist &chemistry_parameters
-
+!-- Initial concentration of profiles is prescribed by parameters cs_profile and cs_heights in the
+!-- namelist &chemistry_parameters.
     CALL chem_init_profiles
-!    
-!-- In case there is dynamic input file, create a list of names for chemistry
-!-- initial input files. Also, initialize array that indicates whether the
-!-- respective variable is on file or not. 
-    IF ( input_pids_dynamic )  THEN    
+!
+!-- In case there is dynamic input file, create a list of names for chemistry initial input files.
+!-- Also, initialize array that indicates whether the respective variable is on file or not.
+    IF ( input_pids_dynamic )  THEN
        ALLOCATE( init_3d%var_names_chem(1:nspec) )
        ALLOCATE( init_3d%from_file_chem(1:nspec) )
        init_3d%from_file_chem(:) = .FALSE.
-       
+
        DO  lsp = 1, nspec
           init_3d%var_names_chem(lsp) = init_3d%init_char // TRIM( chem_species(lsp)%name )
@@ -2108,5 +2107,5 @@
 !
 !-- Initialize model variables
-    IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.            &
+    IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.                                &
          TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
 !
@@ -2126,11 +2125,10 @@
                    ENDDO
                 ENDDO
-             ENDDO   
+             ENDDO
           ENDDO
 
-       ELSEIF ( INDEX(initializing_actions, 'set_constant_profiles') /= 0 )    &
-       THEN
-
-          DO  lsp = 1, nspec 
+       ELSEIF ( INDEX( initializing_actions, 'set_constant_profiles') /= 0 )  THEN
+
+          DO  lsp = 1, nspec
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
